﻿;03.04.2024,17:19 new icon
Enumeration
  #tt
EndEnumeration

;some data for zlib
Structure Z_STREAM
  *next_in.Byte
  avail_in.l
  total_in.l
  *next_out.Byte
  avail_out.l
  total_out.l
  *msg.Byte
  *state
  zalloc.l
  zfree.l
  opaque.l
  data_type.i
  adler.l
  reserved.l
EndStructure

#ENABLE_GZIP = 16
#Z_NULL = 0
#ZLIB_VERSION = "1.2.8"

#Z_FINISH = 4
#Z_NO_FLUSH=0
#Z_DEFAULT_COMPRESSION = -1
#Z_DEFLATED = 8
#MAX_MEM_LEVEL = 9
#Z_DEFAULT_STRATEGY = 0


Import "zlibstat.lib"
  inflateInit2_(*strm, windowBits.i, Version.s, strm_size) As "_inflateInit2_@16"
  inflate(*strm, flush.i) As "_inflate@8"
  inflateEnd(*strm) As "_inflateEnd@4"
EndImport

Global *t=AllocateMemory(32768)

Procedure addt(l$)
  c$=GetGadgetText(#tt)
  If c$
    c$+#CRLF$
  EndIf
  
  SetGadgetText(#tt,c$+l$)
EndProcedure

Procedure loadp(f$)
If f$

  SetGadgetText(#tt,"file:"+f$)
  
  fs=FileSize(f$)
  If fs
*m=AllocateMemory(fs)

If *m
  
If ReadFile(0,f$)
ReadData(0,*m,fs)
CloseFile(0)

*p=*m
;https://www.w3.org/TR/2003/REC-PNG-20031110/
;A PNG file is composed of an 8-byte signature header, followed by any number of chunks that contain control data / metadata / image data.
;Each chunk contains three standard fields – 4-byte length, 4-byte type code, 4-byte CRC – And various internal fields that depend on the chunk type.
;tEXt=74584574
;zTXt=7458547A
;iTXt=74585469
While *p<=*m+fs
  t.l=PeekL(*p)
  cs.l=(PeekA(*p-4)<<24) +(PeekA(*p-3)<<16)+(PeekA(*p-2)<<8)+(PeekA(*p-1))
  *p+1
  If t=$74584574;tEXt
                ;Keyword	1-79 bytes (character string)
                ;Null separator	1 byte (null character)
                ;Text string	0 Or more bytes (character string)
    *p+3
    ;ShowMemoryViewer(*p,1024)
    If cs
      k$=""
      v$=""
      For i=0 To cs-1
        If PeekA(*p+i)=0
          k$=PeekS(*p,i,#PB_Ascii)
          v$=PeekS(*p+i+1,cs-i-1,#PB_Ascii)
          Break
        EndIf
      Next i
      ;Debug "tEXt : "+k$+" "+v$ ; must be 13,10
      addt("tEXt : "+k$+" "+v$) ; must be 13,10
      *p+cs+4
    Else
      ;Debug "tEXt : wrong size"
      addt("tEXt : wrong size")
      End
    EndIf
    
  ElseIf t=$7458547A;zTXt
                    ;Keyword 1-79 bytes (character string) 
                    ;Null separator 1 byte (null character) 
                    ;Compression method 1 byte 
                    ;Compressed text datastream n bytes 
    *p+3
    If PeekA(*p)
      i=0
      k$=""
      While PeekA(*p+i)
        i+1
        k$=PeekS(*p,i,#PB_Ascii)
      Wend
      *p=*p+i+1
      ;compression method
      If PeekA(*p)=0
        *p+1
        FillMemory(*t,0,32768)
        ts.s=Space(32768)
  windowBits=15
  LengthToRead = 32760
  LengthToWrite = 32760
  strm.Z_STREAM
  strm\next_in = *p
  strm\avail_in = cs;$41
  strm\next_out = *t
  strm\avail_out = LengthToWrite
  strm\total_out = 0;reset counter
  strm\zalloc = #Z_NULL
  strm\zfree = #Z_NULL
  strm\opaque = #Z_NULL
  inflateInit2_(@strm, windowBits, #ZLIB_VERSION, SizeOf(Z_STREAM))
  res=inflate(@strm, #Z_FINISH)
  inflateEnd(@strm)
  ;ShowMemoryViewer(*t,1024)
  k$="zTXt: "+k$+" "+PeekS(*t,strm\total_out,#PB_Ascii)
  ;Debug k$
  addt(k$)
;  Return
      Else
;        Debug "zTXt: unkn method:"
        addt("zTXt: unkn method:")
      EndIf
    Else
;      Debug "zTXt: no keyword"
      addt("zTXt: no keyword")
    EndIf
    
  ElseIf t=$74585469;iTXt
                    ; Keyword 1-79 bytes (character string) 
                    ; Null separator 1 byte (null character) 
                    ; Compression flag 1 byte 
                    ; Compression method 1 byte 
                    ; Language tag 0 Or more bytes (character string) 
                    ; Null separator 1 byte (null character) 
                    ; Translated keyword 0 Or more bytes 
                    ; Null separator 1 byte (null character) 
                    ; Text 0 Or more bytes 
    *p+3
    *n=*p
    If PeekA(*p)
      i=0
      k$=""
      While PeekA(*p+i)
        i+1
        k$=PeekS(*p,i,#PB_Ascii)
      Wend
      *p=*p+i+1+2 ;+2-skip compression flags
      If PeekA(*p)
        k$="("+PeekS(*p,2,#PB_Ascii)+")"+k$
        *p+2
      Else
      EndIf
      *p+1
      ;Translated keyword 0 Or more bytes
      If PeekA(*p)
        i=0
        w$=""
        While PeekA(*p+i)
          i+1
          w$=PeekS(*p,i,#PB_UTF8)
        Wend
        k$=k$+"("+w$+")"
        *p=*p+i
        ;ShowMemoryViewer(*p,1024)
      Else
        k$=k$+"(??)"
      EndIf
      *p+1
      k$=k$+" "+PeekS(*p,cs-(*p-*n),#PB_UTF8)
      ;Debug "iTXt : "+k$
      addt("iTXt : "+k$)
    Else
      ;Debug "iTXt : no keyword"
      addt("iTXt : no keyword")
    EndIf;If PeekA(*p)
    
  EndIf
Wend

Else
    MessageRequester("File","Cannot read file")
  EndIf;If ReadFile(0,f$)
  
FreeMemory(*m)
Else
    MessageRequester("File","Cannot allocate memory")
EndIf;If *m

Else
  MessageRequester("File","Wrong size!")
EndIf;If fs
EndIf;If f$  
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "PNG text chunks", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  StringGadget(#tt, 0,  0, 640, 460, "",#ESB_DISABLE_BOTH |#WS_VSCROLL | #ES_MULTILINE);#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL)
  EnableGadgetDrop(#tt,#PB_Drop_Files,#PB_Drag_Copy)
  
  ;SetGadgetText(#tt,"huj"+#CRLF$+"pizdec")
  If CountProgramParameters()
;     f$=ProgramParameter(0)
;     Gosub loadp
    loadp(ProgramParameter(0))
  EndIf
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    Select ev
      Case #PB_Event_GadgetDrop
;         f$=EventDropFiles()
;         Gosub loadp
        loadp(EventDropFiles())
    EndSelect
  Until ev = #PB_Event_CloseWindow
EndIf

FreeMemory(*t)
End

; loadp2:
; If f$
; ;f$="zTXt-chunks.png"
;   SetGadgetText(#tt,"file:"+f$)
;   
;   fs=FileSize(f$)
;   If fs
; *m=AllocateMemory(fs)
; 
; If *m
;   
; If ReadFile(0,f$)
; ReadData(0,*m,fs)
; CloseFile(0)
; 
; *p=*m
; ;https://www.w3.org/TR/2003/REC-PNG-20031110/
; ;A PNG file is composed of an 8-byte signature header, followed by any number of chunks that contain control data / metadata / image data.
; ;Each chunk contains three standard fields – 4-byte length, 4-byte type code, 4-byte CRC – And various internal fields that depend on the chunk type.
; ;tEXt=74584574
; ;zTXt=7458547A
; ;iTXt=74585469
; While *p<=*m+fs
;   t.l=PeekL(*p)
;   cs.l=(PeekA(*p-4)<<24) +(PeekA(*p-3)<<16)+(PeekA(*p-2)<<8)+(PeekA(*p-1))
;   *p+1
;   If t=$74584574;tEXt
;                 ;Keyword	1-79 bytes (character string)
;                 ;Null separator	1 byte (null character)
;                 ;Text string	0 Or more bytes (character string)
;     *p+3
;     If cs
;       k$=""
;       v$=""
;       For i=0 To cs-1
;         If PeekA(*p+i)=0
;           k$=PeekS(*p,i,#PB_Ascii)
;           v$=PeekS(*p+i+1,cs-i-1,#PB_Ascii)
;           Break
;         EndIf
;       Next i
;       ;Debug "tEXt : "+k$+" "+v$ ; must be 13,10
;       addt("tEXt : "+k$+" "+v$) ; must be 13,10
;       *p+cs+4
;     Else
;       ;Debug "tEXt : wrong size"
;       addt("tEXt : wrong size")
;       End
;     EndIf
;     
;   ElseIf t=$7458547A;zTXt
;                     ;Keyword 1-79 bytes (character string) 
;                     ;Null separator 1 byte (null character) 
;                     ;Compression method 1 byte 
;                     ;Compressed text datastream n bytes 
;     *p+3
;     If PeekA(*p)
;       i=0
;       k$=""
;       While PeekA(*p+i)
;         i+1
;         k$=PeekS(*p,i,#PB_Ascii)
;       Wend
;       *p=*p+i+1
;       ;compression method
;       If PeekA(*p)=0
;         *p+1
;         FillMemory(*t,0,32768)
;         ts.s=Space(32768)
;   windowBits=15
;   LengthToRead = 32760
;   LengthToWrite = 32760
;   strm.Z_STREAM
;   strm\next_in = *p
;   strm\avail_in = cs;$41
;   strm\next_out = *t
;   strm\avail_out = LengthToWrite
;   strm\total_out = 0;reset counter
;   strm\zalloc = #Z_NULL
;   strm\zfree = #Z_NULL
;   strm\opaque = #Z_NULL
;   inflateInit2_(@strm, windowBits, #ZLIB_VERSION, SizeOf(Z_STREAM))
;   res=inflate(@strm, #Z_FINISH)
;   inflateEnd(@strm)
;   ;ShowMemoryViewer(*t,1024)
;   k$="zTXt: "+k$+" "+PeekS(*t,strm\total_out,#PB_Ascii)
;   ;Debug k$
;   addt(k$)
; ;  Return
;       Else
; ;        Debug "zTXt: unkn method:"
;         addt("zTXt: unkn method:")
;       EndIf
;     Else
; ;      Debug "zTXt: no keyword"
;       addt("zTXt: no keyword")
;     EndIf
;     
;   ElseIf t=$74585469;iTXt
;                     ; Keyword 1-79 bytes (character string) 
;                     ; Null separator 1 byte (null character) 
;                     ; Compression flag 1 byte 
;                     ; Compression method 1 byte 
;                     ; Language tag 0 Or more bytes (character string) 
;                     ; Null separator 1 byte (null character) 
;                     ; Translated keyword 0 Or more bytes 
;                     ; Null separator 1 byte (null character) 
;                     ; Text 0 Or more bytes 
;     *p+3
;     *n=*p
;     If PeekA(*p)
;       i=0
;       k$=""
;       While PeekA(*p+i)
;         i+1
;         k$=PeekS(*p,i,#PB_Ascii)
;       Wend
;       *p=*p+i+1+2 ;+2-skip compression flags
;       If PeekA(*p)
;         k$="("+PeekS(*p,2,#PB_Ascii)+")"+k$
;         *p+2
;       Else
;       EndIf
;       *p+1
;       ;Translated keyword 0 Or more bytes 
;       If PeekA(*p)
;         i=0
;         w$=""
;         While PeekA(*p+i)
;           i+1
;           w$=PeekS(*p,i,#PB_UTF8)
;         Wend
;         k$=k$+"("+w$+")"
;         *p=*p+i
;         ;ShowMemoryViewer(*p,1024)
;       Else
;       EndIf
;       *p+1
;       k$=k$+" "+PeekS(*p,cs-(*p-*n),#PB_UTF8)
;       ;Debug "iTXt : "+k$
;       addt("iTXt : "+k$)
;     Else
;       ;Debug "iTXt : no keyword"
;       addt("iTXt : no keyword")
;     EndIf;If PeekA(*p)
;     
;   EndIf
; Wend
; 
; Else
;     MessageRequester("File","Cannot read file")
;   EndIf;If ReadFile(0,f$)
;   
; FreeMemory(*m)
; Else
;     MessageRequester("File","Cannot allocate memory")
; EndIf;If *m
; 
; Else
;   MessageRequester("File","Wrong size!")
; EndIf;If fs
; EndIf;If f$
; Return
; IDE Options = PureBasic 5.30 (Windows - x86)
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = pngc3.ico
; Executable = pngc.exe
; CommandLine = cb5c89bf11371e2f9c928e59e0dbb161.png